#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <libxml/xmlmemory.h>
#include <libxml/parser.h>
#include<time.h>

void validate_email(char str[],int len){

char localpart[35];
char domain[35];
int i=0,in1=0,in2=0;
char new_str[60];

strcpy(new_str,str);

//printf("String inside VALIDATE=%s\n",str);


if(new_str[0]=='<' && new_str[len-1]=='>'){
while(i<(len-2)){
new_str[i]=new_str[i+1];
i++;
}
new_str[i]='\0';
//printf("NEW STRING =%s\n",new_str);
}

i=0;

while(new_str[i]!='\0'){

while(new_str[i]!='@'){
localpart[in1]=new_str[i];
i++;in1++;
}
localpart[in1]='\0';
i++;
while(new_str[i]!='\0'){
domain[in2]=new_str[i];
i++;
in2++;

}
domain[in2]='\0';
}

//printf("Local part=%s\n",localpart);
//printf("Domain=%s\n",domain);

char * pos=strchr(localpart,'(');
if(pos)
{
printf("Invalid local part of header field\n");
}

pos=strchr(localpart,')');
if(pos)
{
printf("Invalid local part of header field\n");
}
pos=strchr(localpart,'<');
if(pos)
{
printf("Invalid local part of header field\n");
}
pos=strchr(localpart,'>');
if(pos)
{
printf("Invalid local part of header field\n");
}
pos=strchr(localpart,'[');
if(pos)
{
printf("Invalid local part of header field\n");
}
pos=strchr(localpart,']');
if(pos)
{
printf("Invalid local part of header field\n");
}
pos=strchr(localpart,':');
if(pos)
{
printf("Invalid local part of header field\n");
}
pos=strchr(localpart,';');
if(pos)
{
printf("Invalid local part of header field\n");
}
pos=strchr(localpart,'@');
if(pos)
{
printf("Invalid local part of header field\n");
}
pos=strchr(localpart,'\\');
if(pos)
{
printf("Invalid local part of header field\n");
}
pos=strchr(localpart,',');
if(pos)
{
printf("Invalid local part of header field\n");
}
pos=strchr(localpart,'.');
if(pos)
{
++pos;
if(*pos=='.')
printf("Invalid local part of header field\n");
}

}//validate_email

char subject[50];
char comments[50];
char *ptr;
char keywords[50];
char orig_date[50];
char date[100];
char retpath[50];
char message_id[50];
char resent_message_id[50];
char resent_date[100];

struct to_field{

char to_display_nm[25][50];
char to_email_id[25][50];

}t;

struct cc_field{

char cc_display_nm[25][50];
char cc_email_id[25][50];

}c;

struct bcc_field{

char bcc_display_nm[25][50];
char bcc_email_id[25][50];

}b;

struct from_field{

char  frm_display_nm[25][50];
char frm_email_id[25][50];

}fr;


struct resent_from{

char rf_display_nm[25][50];
char rf_email_id[25][50];


}rf;

struct resent_to{

char rt_display_nm[25][50];
char rt_email_id[25][50];


}rt;

struct resent_cc{

char rc_display_nm[25][50];
char rc_email_id[25][50];


}rc;


struct resent_bcc{

char rb_display_nm[25][50];
char rb_email_id[25][50];


}rb;

struct reply_to_field{

char reply_to_display_nm[25][50];
char reply_to_email_id[25][50];

}rto;

struct received{
char recvd_frm[50];
char recvd_with[25];
char recvd_via[25];
char recvd_by[25];
char recvd_for[50];
char recvd_date[50];
char recvd_id[25];
}r[10];




struct parse_header{
        
      
        struct received *ptr_received;
        char *ptr_resent_date;
        struct resent_from *ptr_resent_from_field;
	struct resent_to *ptr_resent_to_field;
	struct resent_cc *ptr_resent_cc_field;
	struct resent_bcc *ptr_resent_bcc_field;
	char *ptr_resent_message_id;
	char *ptr_orig_date;
	struct from_field *ptr_from_field;
	struct to_field *ptr_to_field;
	struct reply_to_field *ptr_reply_to_field;
	struct cc_field *ptr_cc_field;
	struct bcc_field *ptr_bcc_field;
	char *ptr_message_id;
	char in_reply_to[20][50];
	char references[20][50];	
	char *ptr_subject;
	char *ptr_comments;
	char *ptr_keywords;
	char *ptr_return_path;
        
}ph;

int flag_to=0,flag_cc=0,flag_bcc=0,flag_frm=0,flag_reply_to=0,flag_sub=0,flag_comments=0,flag_keywrd=0,flag_date=0,flag_return_path=0;
int flag_recvd=0,flag_recvd_date=0,flag_inrplyto=0,flag_ref=0,flag_msgid=0,flag_rmsgid=0,stindx=0,rindx=0;
int flag_resent_to=0,flag_resent_cc=0,flag_resent_bcc=0,flag_resent_frm=0,flag_resent_date=0;
int to_index=0,rf_index=0,rt_index=0,rc_index=0,rb_index=0,frm_index=0,rto_index=0,cc_index=0,bcc_index=0,in_reply_to_index=0,ref_index=0;
int m1=0,m2=0,m3=0;
int r1=0,r2=0,r3=0,r4=0,r5=0,r6=0;

void parse_fields(xmlDocPtr doc, xmlNodePtr cur) {


        xmlAttrPtr attr;
        xmlChar *key;
	 
         cur = cur->xmlChildrenNode;
	 while (cur != NULL) {

                    if(xmlStrcmp(cur->name, (const xmlChar *) "text")){
	   
                  //  printf("element's name: %s \n",cur->name);

                   if(!xmlStrcmp(cur->name,(const xmlChar *)"to")){
                      //    printf("found to!!\n");
                          flag_to=1;
                          stindx=to_index;
                       }

                   if(!xmlStrcmp(cur->name,(const xmlChar *)"resent-to")){
                       //   printf("found resent-to!!\n");
                          flag_resent_to=1;
                          stindx=rt_index;
                          r1=1;

                    }
                   
                    if(!xmlStrcmp(cur->name,(const xmlChar *)"cc")){
                      //    printf("found cc!!\n");
                          flag_cc=1;
                          stindx=cc_index;
                      }

                    if(!xmlStrcmp(cur->name,(const xmlChar *)"resent-cc")){
                      //    printf("found resnet-cc!!\n");
                          flag_resent_cc=1;
                          stindx=rc_index;
                          r2=1;
                      }

                    if(!xmlStrcmp(cur->name,(const xmlChar *)"bcc")){
                      //    printf("found bcc!!\n");
                          flag_bcc=1;
                          stindx=bcc_index;
                      }

                   if(!xmlStrcmp(cur->name,(const xmlChar *)"resent-bcc")){
                       //   printf("found resent-bcc!!\n");
                          flag_resent_bcc=1;
                          stindx=rb_index;
                          r3=1;
                      }

                   if(!xmlStrcmp(cur->name,(const xmlChar *)"from")){
                     //     printf("found from!!\n");
                          flag_frm=1;
                          stindx=frm_index;
                          m1=1;
                      }

                  if(!xmlStrcmp(cur->name,(const xmlChar *)"resent-from")){
                        //  printf("found resent-from!!\n");
                          flag_resent_frm=1;
                          stindx=rf_index;
                          r5=1;
                      }

                    if(!xmlStrcmp(cur->name,(const xmlChar *)"reply-to")){
                       //   printf("found reply-to!!\n");
                          flag_reply_to=1;
                          stindx=rto_index;
                      }

                     if(!xmlStrcmp(cur->name,(const xmlChar *)"subject")){
                      //    printf("found subject!!\n");
                          flag_sub=1;
                         
                      }

                      if(!xmlStrcmp(cur->name,(const xmlChar *)"comments")){
                       //   printf("found comments!!\n");
                          flag_comments=1;
                         
                      }

                      if(!xmlStrcmp(cur->name,(const xmlChar *)"keywords")){
                     //     printf("found keywords!!\n");
                          flag_keywrd=1;
                         
                      }

                      if(!xmlStrcmp(cur->name,(const xmlChar *)"orig-date")){
                        //  printf("found orig-date!!\n");
                          flag_date=1; 
                          m2=1;  
                      }

                      if(!xmlStrcmp(cur->name,(const xmlChar *)"resent-date")){
                      //    printf("found resent-date!!\n");
                          flag_resent_date=1;
                          r6=1;   
                      }

                      if(!xmlStrcmp(cur->name,(const xmlChar *)"return-path")){
                       //   printf("found return-path!!\n");
                          flag_return_path=1;
                         
                      }

                      if(!xmlStrcmp(cur->name,(const xmlChar *)"received")){
                      //    printf("found received!!\n");
                          flag_recvd=1;
                      }

                      if(!xmlStrcmp(cur->name,(const xmlChar *)"message-id")){
                       //   printf("found message-id!!\n");
                          flag_msgid=1;  
                          m3=1; 
                       }

                       if(!xmlStrcmp(cur->name,(const xmlChar *)"resent-message-id")){
                       //   printf("found resent-message-id!!\n");
                          flag_rmsgid=1;
                          r4=1;   
                       }

                       if(!xmlStrcmp(cur->name,(const xmlChar *)"references")){
                        //  printf("found references!!\n");
                          flag_ref=1;
                          stindx=ref_index;
                       }

                       if(!xmlStrcmp(cur->name,(const xmlChar *)"in-reply-to")){
                        //  printf("found in-reply-to!!\n");
                          flag_inrplyto=1;
                          stindx=in_reply_to_index;
                       }
                                              
                       if(!xmlStrcmp(cur->name,(const xmlChar *)"date")){
                        //  printf("found received_date!!\n");
                          flag_recvd_date=1;  
                          
                       }
                     
                    for(attr = cur->properties; attr != NULL; attr = attr->next) {  
                    if(attr->name != NULL) {

                    if(flag_to==1){
                  //  printf("element's attribute: %s\n",attr->name);
	           // printf("element's attribute's value: %s\n",attr->children->content);
                    strcpy(t.to_display_nm[stindx],(char *)attr->children->content);
                  //  printf("To's display name=%s,length of display name=%d\n",t.to_display_nm[stindx],strlen(t.to_display_nm[stindx]));
                    } 

                    if(flag_resent_to==1){
                  //  printf("element's attribute: %s\n",attr->name);
	           // printf("element's attribute's value: %s\n",attr->children->content);
                    strcpy(rt.rt_display_nm[stindx],(char *)attr->children->content);
                  //  printf("Resent-To's display name=%s,length of display name=%d\n",rt.rt_display_nm[stindx],strlen(rt.rt_display_nm[stindx]));
                    } 
                   
                    if(flag_cc==1){
                  //  printf("element's attribute: %s\n",attr->name);
	          //  printf("element's attribute's value: %s\n",attr->children->content);
                    strcpy(c.cc_display_nm[stindx],(char *)attr->children->content);
                  //  printf("Cc display name=%s,length of display name=%d\n",c.cc_display_nm[stindx],strlen(c.cc_display_nm[stindx]));
                    } 

                    if(flag_resent_cc==1){
                  //  printf("element's attribute: %s\n",attr->name);
	          //  printf("element's attribute's value: %s\n",attr->children->content);
                    strcpy(rc.rc_display_nm[stindx],(char *)attr->children->content);
                //    printf("Resent-Cc display name=%s,length of display name=%d\n",rc.rc_display_nm[stindx],strlen(rc.rc_display_nm[stindx]));
                    } 



                    if(flag_bcc==1){
                 //   printf("element's attribute: %s\n",attr->name);
	         //   printf("element's attribute's value: %s\n",attr->children->content);
                    strcpy(b.bcc_display_nm[stindx],(char *)attr->children->content);
                  //  printf("Bcc display name=%s,length of display name=%d\n",b.bcc_display_nm[stindx],strlen(b.bcc_display_nm[stindx]));
                    } 


                     if(flag_resent_bcc==1){
                 //   printf("element's attribute: %s\n",attr->name);
	         //   printf("element's attribute's value: %s\n",attr->children->content);
                    strcpy(rb.rb_display_nm[stindx],(char *)attr->children->content);
                  //  printf("Bcc display name=%s,length of display name=%d\n",rb.rb_display_nm[stindx],strlen(rb.rb_display_nm[stindx]));
                    } 

                     

                     if(flag_frm==1){
                     //  printf("element's attribute: %s\n",attr->name);
	             // printf("element's attribute's value: %s\n",attr->children->content);
                    strcpy(fr.frm_display_nm[stindx],(char *)attr->children->content);
                //    printf("From display name=%s,length of display name=%d\n",fr.frm_display_nm[stindx],strlen(fr.frm_display_nm[stindx]));
                    } 


                   if(flag_resent_frm==1){
                     //  printf("element's attribute: %s\n",attr->name);
	             // printf("element's attribute's value: %s\n",attr->children->content);
                    strcpy(rf.rf_display_nm[stindx],(char *)attr->children->content);
                 //   printf("Resent-From display name=%s\n",rf.rf_display_nm[stindx],strlen(rf.rf_display_nm[stindx]));
                    } 
                    
                      

                    if(flag_reply_to==1){
                    //  printf("element's attribute: %s\n",attr->name);
	           // printf("element's attribute's value: %s\n",attr->children->content);
                    strcpy(rto.reply_to_display_nm[stindx],(char *)attr->children->content);
                 //   printf("Reply-to display name=%s,length of display name=%d\n",rto.reply_to_display_nm[stindx],strlen(rto.reply_to_display_nm[stindx]));
                    } 

                   
                    
                   if(flag_recvd==1){
               
                   

                    if(!xmlStrcmp(attr->name,(const xmlChar *)"from")){
                //    printf("found recvd-from\n");
                    strcpy(r[rindx].recvd_frm,(char *)attr->children->content);
                //    printf("Recvd From=%s indx=%d\n",r[rindx].recvd_frm,rindx);
                    }

                    if(!xmlStrcmp(attr->name,(const xmlChar *)"by")){
                    strcpy(r[rindx].recvd_by,(char *)attr->children->content);
                 //   printf("Recvd by=%s\n",r[rindx].recvd_by);
                    }
                    
                    if(!xmlStrcmp(attr->name,(const xmlChar *)"with")){
                    strcpy(r[rindx].recvd_with,(char *)attr->children->content);
                //    printf("Recvd with=%s\n",r[rindx].recvd_with);
                    }

                    if(!xmlStrcmp(attr->name,(const xmlChar *)"via")){
                    strcpy(r[rindx].recvd_via,(char *)attr->children->content);
                //   printf("Recvd via=%s\n",r[rindx].recvd_via);
                    }
                    

                    if(!xmlStrcmp(attr->name,(const xmlChar *)"for")){
                    strcpy(r[rindx].recvd_for,(char *)attr->children->content);
                   // printf("Recvd for=%s\n",r[rindx].recvd_for);
                    }

                     if(!xmlStrcmp(attr->name,(const xmlChar *)"id")){
                    strcpy(r[rindx].recvd_id,(char *)attr->children->content);
                  //  printf("Recvd id=%s\n",r[rindx].recvd_for);
                    }

                    } //if recvd
                   
		    }//if attr not null
		    }//for
                    
		    key = xmlNodeListGetString(doc, cur->xmlChildrenNode, 1);
		   // printf("element's content: %s\n", key);
                    if(flag_to==1){
                    strcpy(t.to_email_id[stindx],(char *)key);
                 //   printf("To email id=%s\n",t.to_email_id[stindx]);
                    stindx++;
               //     printf("To index=%d\n",stindx);
                    flag_to=0;
                    to_index=stindx;
                    }

                    if(flag_resent_to==1){
                    strcpy(rt.rt_email_id[stindx],(char *)key);
                //    printf("Resent-To email id=%s\n",rt.rt_email_id[stindx]);
                    stindx++;
                 //   printf("Resent-To index=%d\n",stindx);
                    flag_resent_to=0;
                    rt_index=stindx;
                    }

                    if(flag_cc==1){
                    strcpy(c.cc_email_id[stindx],(char *)key);
                 //   printf("Cc email id=%s\n",c.cc_email_id[stindx]);
                    stindx++;
                 //   printf("Cc index=%d\n",stindx);
                    flag_cc=0;
                    cc_index=stindx;
                    }

                    if(flag_resent_cc==1){
                    strcpy(rc.rc_email_id[stindx],(char *)key);
                  //  printf("Resent-Cc email id=%s\n",rc.rc_email_id[stindx]);
                    stindx++;
                  //  printf("Resent-Cc index=%d\n",stindx);
                    flag_resent_cc=0;
                    rc_index=stindx;
                    }

                    if(flag_bcc==1){
                    strcpy(b.bcc_email_id[stindx],(char *)key);
                  //  printf("Bcc email id=%s\n",b.bcc_email_id[stindx]);
                    stindx++;
                 //   printf("Bcc index=%d\n",stindx);
                    flag_bcc=0;
                    bcc_index=stindx;
                    }

                    if(flag_resent_bcc==1){
                    strcpy(rb.rb_email_id[stindx],(char *)key);
                  //  printf("Resent-Bcc email id=%s\n",rb.rb_email_id[stindx]);
                    stindx++;
                  //  printf("Resent-Bcc index=%d\n",stindx);
                    flag_resent_bcc=0;
                    rb_index=stindx;
                    }     


                    if(flag_frm==1){
                    strcpy(fr.frm_email_id[stindx],(char *)key);
                //    printf("From email id=%s\n",fr.frm_email_id[stindx]);
                    stindx++;
                 //   printf("From index=%d\n",stindx);
                    flag_frm=0;
                    frm_index=stindx;
                    }

                   if(flag_resent_frm==1){
                    strcpy(rf.rf_email_id[stindx],(char *)key);
                  //  printf("Resent-From email id=%s\n",rf.rf_email_id[stindx]);
                    stindx++;
                //    printf("Resent-From index=%d\n",stindx);
                    flag_resent_frm=0;
                    rf_index=stindx;
                    }

                    if(flag_reply_to==1){
                    strcpy(rto.reply_to_email_id[stindx],(char *)key);
                 //   printf("Reply-to email id=%s\n",rto.reply_to_email_id[stindx]);
                    stindx++;
                 //   printf("Reply-to index=%d\n",stindx);
                    flag_reply_to=0;
                    rto_index=stindx;
                    }
                 
                    if(flag_sub==1){
                    strcpy(subject,(char *)key);
                 //   printf("Subject=%s\n",subject);
                    flag_sub=0;
                    }

                    if(flag_keywrd==1){
                    strcpy(keywords,(char *)key);
                 //   printf("Keywords=%s\n",keywords);
                    flag_keywrd=0;
                    }

                    if(flag_comments==1){
                    strcpy(comments,(char *)key);
               //     printf("Comments=%s\n",comments);
                    flag_comments=0;
                    }
                      
                    if(flag_date==1){
                    strcpy(orig_date,(char *)key);
                //    printf("Date=%s\n",date);
                    flag_date=0;
                    }

                    
                    if(flag_resent_date==1){
                    strcpy(resent_date,(char *)key);
               //     printf("Resent-Date=%s\n",resent_date);
                    flag_resent_date=0;
                    }
                     
                    if(flag_recvd_date==1){
                    strcpy(r[rindx].recvd_date,(char *)key);
                  //  printf("Rindx=%d\n",rindx);
               //     printf("Recvd-Date=%s\n",r[rindx].recvd_date);
                    rindx++;
                    flag_recvd_date=0;
                    }

                    if(flag_return_path==1){
                    strcpy(retpath,(char *)key);
                  //  printf("Return-Path=%s\n",retpath);
                    flag_return_path=0;
                    }

                    if(flag_msgid==1){
                    strcpy(message_id,(char *)key);
                //    printf("Message-Id=%s\n",message_id);
                    flag_msgid=0;
                    }
                  
                    if(flag_rmsgid==1){
                    strcpy(resent_message_id,(char *)key);
               //     printf("Resent-Message-Id=%s\n",resent_message_id);
                    flag_rmsgid=0;
                    }

                    if(flag_inrplyto==1){
                    strcpy(ph.in_reply_to[stindx],(char *)key);
                 //   printf("In-Reply-To=%s\n",ph.in_reply_to[stindx]);
                    flag_inrplyto=0;   
                    stindx++;
                    in_reply_to_index=stindx;
                    }  

                    if(flag_ref==1){
                    strcpy(ph.references[stindx],(char *)key);
                 //   printf("References=%s\n",ph.references[stindx]);
                    flag_ref=0;   
                    stindx++;
                    ref_index=stindx;
                    }  
                 
		    xmlFree(key);
                    parse_fields(doc, cur);
                   
 	            }
       
	cur = cur->next;
	}
   // return;
}

void validate_fields(){


if(m1==0 || m2==0 || m3==0){
printf("mandatory fields missing\n");

}


if((r1==1 || r2==1 || r3==1 || r4==1) && (r5==0 || r6==0)){
printf("Resent-Date and Resent-From are mandatory for the block of resent-fields\n");

}

}
void print_result(){


struct parse_header *ptr_parsed_fields=&ph;

printf("Accessing through a pointer we have:\n");
printf("Return-Path=%s\n",ptr_parsed_fields->ptr_return_path); 




int loop=0;

//printf("rindx before loop=%s\n",r[1].recvd_frm);
for(loop=0;loop<rindx;loop++)
{
if(strcmp(r[loop].recvd_frm,"")==0||strcmp(r[loop].recvd_frm," ")==0){}
else
printf("Received-from=%s\n",ph.ptr_received->recvd_frm);
if(strcmp(r[loop].recvd_with,"")==0||strcmp(r[loop].recvd_with," ")==0){}
else
printf("Received-with=%s\n",ptr_parsed_fields->ptr_received->recvd_with);
if(strcmp(r[loop].recvd_via,"")==0||strcmp(r[loop].recvd_via," ")==0){}
else
printf("Received-via=%s\n",ptr_parsed_fields->ptr_received->recvd_via);
if(strcmp(r[loop].recvd_for,"")==0||strcmp(r[loop].recvd_for," ")==0){}
else
printf("Received-for=%s\n",ptr_parsed_fields->ptr_received->recvd_for);
if(strcmp(r[loop].recvd_by,"")==0||strcmp(r[loop].recvd_by," ")==0){}
else
printf("Received-by=%s\n",ptr_parsed_fields->ptr_received->recvd_by);
if(strcmp(r[loop].recvd_date,"")==0||strcmp(r[loop].recvd_date," ")==0){}
else
printf("Received-date=%s\n",ptr_parsed_fields->ptr_received->recvd_date);

ph.ptr_received++;
}
printf("Resent-Date=%s\n",ptr_parsed_fields->ptr_resent_date);
for(loop=0;loop<rf_index;loop++)
{
validate_email(rf.rf_email_id[loop],strlen(rf.rf_email_id[loop]));
printf("Resent-From email id=%s\n",ptr_parsed_fields->ptr_resent_from_field->rf_email_id[loop]);
if(strcmp(rf.rf_display_nm[loop],"")==0 || strcmp(rf.rf_display_nm[loop]," ")==0)continue;
else
printf("Resent-From display name=%s\n",ptr_parsed_fields->ptr_resent_from_field->rf_display_nm[loop]);
}

for(loop=0;loop<rt_index;loop++)
{
validate_email(rt.rt_email_id[loop],strlen(rt.rt_email_id[loop]));
printf("Resent-To email id=%s\n",ptr_parsed_fields->ptr_resent_to_field->rt_email_id[loop]);
if(strcmp(rt.rt_display_nm[loop],"")==0 || strcmp(rt.rt_display_nm[loop]," ")==0)continue;
else
printf("Resent-To display name=%s\n",ptr_parsed_fields->ptr_resent_to_field->rt_display_nm[loop]);
}
for(loop=0;loop<rc_index;loop++)
{
validate_email(rc.rc_email_id[loop],strlen(rc.rc_email_id[loop]));
printf("Resent-Cc email id=%s\n",ptr_parsed_fields->ptr_resent_cc_field->rc_email_id[loop]);
if(strcmp(rc.rc_display_nm[loop],"")==0 || strcmp(rc.rc_display_nm[loop]," ")==0)continue;
else
printf("Resent-Cc display name=%s\n",ptr_parsed_fields->ptr_resent_cc_field->rc_display_nm[loop]);
}

for(loop=0;loop<rb_index;loop++)
{
validate_email(rb.rb_email_id[loop],strlen(rb.rb_email_id[loop]));
printf("Resent-Bcc email id=%s\n",ptr_parsed_fields->ptr_resent_bcc_field->rb_email_id[loop]);
if(strcmp(rb.rb_display_nm[loop],"")==0 || strcmp(rb.rb_display_nm[loop]," ")==0)continue;
else
printf("Resent-Bcc display name=%s\n",ptr_parsed_fields->ptr_resent_bcc_field->rb_display_nm[loop]);
}

printf("Resent-Message-Id=%s\n",ptr_parsed_fields->ptr_resent_message_id);
printf("Date=%s\n",ptr_parsed_fields->ptr_orig_date);

for(loop=0;loop<frm_index;loop++)
{
validate_email(fr.frm_email_id[loop],strlen(fr.frm_email_id[loop]));
printf("From email id=%s\n",ptr_parsed_fields->ptr_from_field->frm_email_id[loop]);
if(strcmp(fr.frm_display_nm[loop],"")==0 || strcmp(fr.frm_display_nm[loop]," ")==0)continue;
else
printf("From display name=%s\n",ptr_parsed_fields->ptr_from_field->frm_display_nm[loop]);
}
for(loop=0;loop<rto_index;loop++)
{
validate_email(rto.reply_to_email_id[loop],strlen(rto.reply_to_email_id[loop]));
printf("Reply-To email id=%s\n",ptr_parsed_fields->ptr_reply_to_field->reply_to_email_id[loop]);
if(strcmp(rto.reply_to_display_nm[loop],"")==0 || strcmp(rto.reply_to_display_nm[loop]," ")==0)continue;
else
printf("Reply-To display name=%s\n",ptr_parsed_fields->ptr_reply_to_field->reply_to_display_nm[loop]);
}
for(loop=0;loop<to_index;loop++)
{
validate_email(t.to_email_id[loop],strlen(t.to_email_id[loop]));
printf("To email id=%s\n",ptr_parsed_fields->ptr_to_field->to_email_id[loop]);
if(strcmp(t.to_display_nm[loop],"")==0 || strcmp(t.to_display_nm[loop]," ")==0)continue;
else
printf("To Display name=%s\n",ptr_parsed_fields->ptr_to_field->to_display_nm[loop]);
}

for(loop=0;loop<cc_index;loop++)
{
validate_email(c.cc_email_id[loop],strlen(c.cc_email_id[loop]));
printf("Cc email id=%s\n",ptr_parsed_fields->ptr_cc_field->cc_email_id[loop]);
if(strcmp(c.cc_display_nm[loop],"")==0 || strcmp(c.cc_display_nm[loop]," ")==0)continue;
else
printf("Cc Display name=%s\n",ptr_parsed_fields->ptr_cc_field->cc_display_nm[loop]);
}

for(loop=0;loop<bcc_index;loop++)
{
validate_email(b.bcc_email_id[loop],strlen(b.bcc_email_id[loop]));
printf("Bcc email id=%s\n",ptr_parsed_fields->ptr_bcc_field->bcc_email_id[loop]);
if(strcmp(b.bcc_display_nm[loop],"")==0 || strcmp(b.bcc_display_nm[loop]," ")==0)continue;
else
printf("Bcc display name=%s\n",ptr_parsed_fields->ptr_bcc_field->bcc_display_nm[loop]);
}

printf("Message-ID=%s\n",ptr_parsed_fields->ptr_message_id);

for(loop=0;loop<in_reply_to_index;loop++)
{
printf("In-Reply-To=%s\n",ptr_parsed_fields->in_reply_to[loop]);
}
for(loop=0;loop<ref_index;loop++)
{
printf("References=%s\n",ptr_parsed_fields->references[loop]);
}
printf("Subject=%s\n",ptr_parsed_fields->ptr_subject);
printf("Comments=%s\n",ptr_parsed_fields->ptr_comments);
printf("Keywords=%s\n",ptr_parsed_fields->ptr_keywords);



}


void call_validate(){

struct parse_header *ptr_parsed_fields=&ph;
int loop=0;

for(loop=0;loop<rf_index;loop++)
{
validate_email(rf.rf_email_id[loop],strlen(rf.rf_email_id[loop]));
if(strcmp(rf.rf_display_nm[loop],"")==0 || strcmp(rf.rf_display_nm[loop]," ")==0)continue;
}

for(loop=0;loop<rt_index;loop++)
{
validate_email(rt.rt_email_id[loop],strlen(rt.rt_email_id[loop]));
if(strcmp(rt.rt_display_nm[loop],"")==0 || strcmp(rt.rt_display_nm[loop]," ")==0)continue;
}
for(loop=0;loop<rc_index;loop++)
{
validate_email(rc.rc_email_id[loop],strlen(rc.rc_email_id[loop]));
if(strcmp(rc.rc_display_nm[loop],"")==0 || strcmp(rc.rc_display_nm[loop]," ")==0)continue;
}

for(loop=0;loop<rb_index;loop++)
{
validate_email(rb.rb_email_id[loop],strlen(rb.rb_email_id[loop]));
if(strcmp(rb.rb_display_nm[loop],"")==0 || strcmp(rb.rb_display_nm[loop]," ")==0)continue;
}


for(loop=0;loop<frm_index;loop++)
{
validate_email(fr.frm_email_id[loop],strlen(fr.frm_email_id[loop]));
if(strcmp(fr.frm_display_nm[loop],"")==0 || strcmp(fr.frm_display_nm[loop]," ")==0)continue;
}
for(loop=0;loop<rto_index;loop++)
{
validate_email(rto.reply_to_email_id[loop],strlen(rto.reply_to_email_id[loop]));
if(strcmp(rto.reply_to_display_nm[loop],"")==0 || strcmp(rto.reply_to_display_nm[loop]," ")==0)continue;
}
for(loop=0;loop<to_index;loop++)
{
validate_email(t.to_email_id[loop],strlen(t.to_email_id[loop]));
if(strcmp(t.to_display_nm[loop],"")==0 || strcmp(t.to_display_nm[loop]," ")==0)continue;

}

for(loop=0;loop<cc_index;loop++)
{
validate_email(c.cc_email_id[loop],strlen(c.cc_email_id[loop]));
if(strcmp(c.cc_display_nm[loop],"")==0 || strcmp(c.cc_display_nm[loop]," ")==0)continue;
}

for(loop=0;loop<bcc_index;loop++)
{
validate_email(b.bcc_email_id[loop],strlen(b.bcc_email_id[loop]));
if(strcmp(b.bcc_display_nm[loop],"")==0 || strcmp(b.bcc_display_nm[loop]," ")==0)continue;
}



}
static void
parse_doc(char *docname) {

    

	xmlDocPtr doc;
	xmlNodePtr cur;
	xmlChar *key;
	xmlAttrPtr attr;
 
        //Parse XML document
	doc = xmlParseFile(docname);
	
	if (doc == NULL ) {
		fprintf(stderr,"Document not parsed successfully. \n");
		return;
	}
	
        //Get Root Element
	cur = xmlDocGetRootElement(doc);
	
	if (cur == NULL) {
		fprintf(stderr,"empty document\n");
		xmlFreeDoc(doc);
		return;
	}
	
        //Check if Root node is internet-message
	if (xmlStrcmp(cur->name, (const xmlChar *) "internet-message")) {
		fprintf(stderr,"document of the wrong type, root node != internet-message");
		xmlFreeDoc(doc);
		return;
	}
        else
	{           //retriving root node's name,attributes and content
                    if(xmlStrcmp(cur->name, (const xmlChar *) "text")){
              //      printf("element's name: %s\n",cur->name);
                    for(attr = cur->properties; attr != NULL; attr = attr->next) {
                    
                    if(attr->name != NULL) {
             //       printf("element's attribute: %s\n",attr->name);
	      //      printf("element's attribute's value: %s\n",attr->children->content);
		    }

		    }
		    key = xmlNodeListGetString(doc, cur->xmlChildrenNode, 1);
		//    printf("element's content: %s\n", key);
		    xmlFree(key);
                    }
	}
         
	
        parse_fields(doc, cur);
        xmlFreeDoc(doc);


//return;
}




int
main(int argc, char **argv) {

int i=0,expmt=0;

double result_times[10];
double sum=0.0;

FILE *output;

output=fopen("execution_time_result_xml.txt","a+");

for(expmt=0;expmt<10;expmt++){

clock_t start = clock();


for(i=0;i<1000;i++){

flag_to=0,flag_cc=0,flag_bcc=0,flag_frm=0,flag_reply_to=0,flag_sub=0,flag_comments=0,flag_keywrd=0,flag_date=0,flag_return_path=0;
flag_recvd=0,flag_recvd_date=0,flag_inrplyto=0,flag_ref=0,flag_msgid=0,flag_rmsgid=0,stindx=0,rindx=0;
flag_resent_to=0,flag_resent_cc=0,flag_resent_bcc=0,flag_resent_frm=0,flag_resent_date=0;
to_index=0,rf_index=0,rt_index=0,rc_index=0,rb_index=0,frm_index=0,rto_index=0,cc_index=0,bcc_index=0,in_reply_to_index=0,ref_index=0;
m1=0,m2=0,m3=0;
r1=0,r2=0,r3=0,r4=0,r5=0,r6=0;

	char *docname;
	//XML file's name is passed through the command line	
	if (argc <= 1) {
		//printf("Usage: %s docname\n", argv[0]);
		return(0);
	}

	docname = argv[1];
	parse_doc(docname);

        validate_fields();
	ph.ptr_to_field=&t;
	ph.ptr_reply_to_field=&rto;
	ph.ptr_from_field=&fr;
	ph.ptr_bcc_field=&b;
	ph.ptr_cc_field=&c;
	ph.ptr_resent_from_field=&rf;
	ph.ptr_resent_to_field=&rt;
	ph.ptr_resent_cc_field=&rc;
	ph.ptr_resent_bcc_field=&rb;
	ph.ptr_message_id=message_id;
	ph.ptr_subject=subject;
	ph.ptr_comments=comments;
	ph.ptr_keywords=keywords;
	ph.ptr_resent_message_id=resent_message_id;
	ph.ptr_resent_date=resent_date;
	ph.ptr_orig_date=orig_date;
	ph.ptr_return_path=retpath;
	ph.ptr_received=&r[0];

        //print_result();
        call_validate();	

}//end of clock loop

result_times[expmt]=((double)(clock() - start)) / CLOCKS_PER_SEC;
//printf("RESULT: Time elapsed: %f\n",result_times[expmt]);
fprintf(output,"RESULT: Time elapsed or CPU time used: %f s\n",result_times[expmt]);
sum=sum+result_times[expmt];

}//end of expmt loop

//printf("AVERAGE TIME=% f\n",(sum/5.0));
fprintf(output,"TOTAL TIME TO RUN THE CODE 1000 times and repeat the experiment 10 times =%f s\n",sum);
fprintf(output,"AVERAGE TIME to run the CODE 1000 times=% f s\n",(sum/10.0));
fprintf(output,"estimated time taken to run the code for one execution( avg time /1000)=% f s\n",(sum/10.0)/1000.0);

fclose(output);

}

